package com.ejie.ab79.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.ejie.x38.serialization.JsonDateDeserializer;
import com.ejie.x38.serialization.JsonDateSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

/**
 * EnviosJson  
 * 
 *  
 */

public class EnviosJson implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private Integer idEnvioJson;
	private String aplicacionOrigen;
	private String aplicacionDestino;
	private Integer idInspector;
	private String metodo;
	private String json;
	private Integer estado;
	private String error;
	private Date fechaRegistro;
	private String usuarioRegistro;
	private List<InspeccionesJson> inspeccionesJsons = new ArrayList<InspeccionesJson>();

	/**
	 * Method 'EnviosJson'.
	 */
	public EnviosJson() {
	}

	/**
	 * Method 'EnviosJson'.
	 * 
	 * @param idEnvioJson
	 *            Integer
	 */
	public EnviosJson(Integer idEnvioJson) {
		this.idEnvioJson = idEnvioJson;
	}

	/**
	 * Method 'EnviosJson'.
	 * 
	 * @param idEnvioJson
	 *            Integer
	 * @param aplicacionOrigen
	 *            String
	 * @param aplicacionDestino
	 *            String
	 * @param idInspector
	 *            Integer
	 * @param metodo
	 *            String
	 * @param json
	 *            String
	 * @param estado
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 */
	public EnviosJson(Integer idEnvioJson, String aplicacionOrigen, String aplicacionDestino, Integer idInspector,
			String metodo, String json, Integer estado, Date fechaRegistro, String usuarioRegistro) {
		this.idEnvioJson = idEnvioJson;
		this.aplicacionOrigen = aplicacionOrigen;
		this.aplicacionDestino = aplicacionDestino;
		this.idInspector = idInspector;
		this.metodo = metodo;
		this.json = json;
		this.estado = estado;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'EnviosJson'.
	 * 
	 * @param idEnvioJson
	 *            Integer
	 * @param aplicacionOrigen
	 *            String
	 * @param aplicacionDestino
	 *            String
	 * @param idInspector
	 *            Integer
	 * @param metodo
	 *            String
	 * @param json
	 *            String
	 * @param estado
	 *            Integer
	 * @param fechaRegistro
	 *            Date
	 * @param usuarioRegistro
	 *            String
	 * @param inspeccionesJsons
	 *            List<InspeccionesJson>
	 */
	public EnviosJson(Integer idEnvioJson, String aplicacionOrigen, String aplicacionDestino, Integer idInspector,
			String metodo, String json, Integer estado, Date fechaRegistro, String usuarioRegistro,
			List<InspeccionesJson> inspeccionesJsons) {

		this.idEnvioJson = idEnvioJson;
		this.aplicacionOrigen = aplicacionOrigen;
		this.aplicacionDestino = aplicacionDestino;
		this.idInspector = idInspector;
		this.metodo = metodo;
		this.json = json;
		this.estado = estado;
		this.fechaRegistro = fechaRegistro;
		this.usuarioRegistro = usuarioRegistro;
		this.inspeccionesJsons = inspeccionesJsons;
	}

	/**
	 * Method 'getIdEnvioJson'.
	 *
	 * @return Integer
	 */

	public Integer getIdEnvioJson() {
		return this.idEnvioJson;
	}

	/**
	 * Method 'setIdEnvioJson'.
	 *
	 * @param idEnvioJson
	 *            Integer
	 * @return
	 */

	public void setIdEnvioJson(Integer idEnvioJson) {
		this.idEnvioJson = idEnvioJson;
	}

	/**
	 * Method 'getAplicacionOrigen'.
	 *
	 * @return String
	 */

	public String getAplicacionOrigen() {
		return this.aplicacionOrigen;
	}

	/**
	 * Method 'setAplicacionOrigen'.
	 *
	 * @param aplicacionOrigen
	 *            String
	 * @return
	 */

	public void setAplicacionOrigen(String aplicacionOrigen) {
		this.aplicacionOrigen = aplicacionOrigen;
	}

	/**
	 * Method 'getAplicacionDestino'.
	 *
	 * @return String
	 */

	public String getAplicacionDestino() {
		return this.aplicacionDestino;
	}

	/**
	 * Method 'setAplicacionDestino'.
	 *
	 * @param aplicacionDestino
	 *            String
	 * @return
	 */

	public void setAplicacionDestino(String aplicacionDestino) {
		this.aplicacionDestino = aplicacionDestino;
	}

	/**
	 * Method 'getIdInspector'.
	 *
	 * @return Integer
	 */

	public Integer getIdInspector() {
		return this.idInspector;
	}

	/**
	 * Method 'setIdInspector'.
	 *
	 * @param idInspector
	 *            Integer
	 * @return
	 */

	public void setIdInspector(Integer idInspector) {
		this.idInspector = idInspector;
	}

	/**
	 * @return the metodo
	 */
	public String getMetodo() {
		return metodo;
	}

	/**
	 * @param metodo
	 *            the metodo to set
	 */
	public void setMetodo(String metodo) {
		this.metodo = metodo;
	}

	/**
	 * Method 'getJson'.
	 *
	 * @return Clob
	 */
	public String getJson() {
		return this.json;
	}

	/**
	 * Method 'setJson'.
	 *
	 * @param json
	 *            String
	 * @return
	 */

	public void setJson(String json) {
		this.json = json;
	}

	/**
	 * Method 'getEstado'.
	 *
	 * @return Integer
	 */

	public Integer getEstado() {
		return this.estado;
	}

	/**
	 * Method 'setEstado'.
	 *
	 * @param estado
	 *            Integer
	 * @return
	 */

	public void setEstado(Integer estado) {
		this.estado = estado;
	}

	public String getError() {
		return error;
	}

	public void setError(String error) {
		this.error = error;
	}

	/**
	 * Method 'getFechaRegistro'.
	 *
	 * @return java.util.Date
	 */

	@JsonSerialize(using = JsonDateSerializer.class)
	public Date getFechaRegistro() {
		return this.fechaRegistro;
	}

	/**
	 * Method 'setFechaRegistro'.
	 *
	 * @param fechaRegistro
	 *            java.util.Date
	 * @return
	 */
	@JsonDeserialize(using = JsonDateDeserializer.class)
	public void setFechaRegistro(Date fechaRegistro) {
		this.fechaRegistro = fechaRegistro;
	}

	/**
	 * Method 'getUsuarioRegistro'.
	 *
	 * @return String
	 */

	public String getUsuarioRegistro() {
		return this.usuarioRegistro;
	}

	/**
	 * Method 'setUsuarioRegistro'.
	 *
	 * @param usuarioRegistro
	 *            String
	 * @return
	 */

	public void setUsuarioRegistro(String usuarioRegistro) {
		this.usuarioRegistro = usuarioRegistro;
	}

	/**
	 * Method 'getInspeccionesJsons'.
	 *
	 * @return List
	 */
	@JsonIgnore
	public List<InspeccionesJson> getInspeccionesJsons() {
		return this.inspeccionesJsons;
	}

	/**
	 * Method 'setInspeccionesJsons'.
	 *
	 * @param inspeccionesJsons
	 *            List
	 * @return
	 */
	public void setInspeccionesJsons(List<InspeccionesJson> inspeccionesJsons) {
		this.inspeccionesJsons = inspeccionesJsons;
	}

	/**
	 * Intended only for logging and debugging.
	 * 
	 * Here, the contents of every main field are placed into the result.
	 * 
	 * @return String
	 */
	@Override
	public String toString() {
		StringBuilder result = new StringBuilder();
		result.append(this.getClass().getName()).append(" Object { ");
		result.append(" [ idEnvioJson: ").append(this.idEnvioJson).append(" ]");
		result.append(", [ aplicacionOrigen: ").append(this.aplicacionOrigen).append(" ]");
		result.append(", [ aplicacionDestino: ").append(this.aplicacionDestino).append(" ]");
		result.append(", [ idInspector: ").append(this.idInspector).append(" ]");
		result.append(", [ metodo: ").append(this.metodo).append(" ]");
		result.append(", [ json: ").append(this.json).append(" ]");
		result.append(", [ estado: ").append(this.estado).append(" ]");
		result.append(", [ fechaRegistro: ").append(this.fechaRegistro).append(" ]");
		result.append(", [ usuarioRegistro: ").append(this.usuarioRegistro).append(" ]");
		result.append("}");
		return result.toString();
	}

}
